umbrello: UMLStereotype Class Reference

umbrello 2.31.1 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

Public Member Functions | Protected Attributes | List of all members
UMLStereotype Class Reference

Sets up stereotype information. More...

`#include <stereotype.h>`

Inheritance diagram for UMLStereotype:

## Public Member Functions
| UMLStereotype (const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLStereotype ()
virtual | ~UMLStereotype ()
bool | operator== (const UMLStereotype &rhs) const
virtual void | copyInto (UMLObject *lhs) const
virtual UMLObject * | clone () const
void | incrRefCount ()
void | decrRefCount ()
int | refCount () const
QString | name (bool includeAdornments=false) const
void | saveToXMI1 (QDomDocument &qDoc, QDomElement &qElement)
virtual bool | showPropertiesDialog (QWidget *parent)
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
virtual void | setBaseType (ObjectType ot)
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype ()
QString | package (const QString &separator=QString(), bool includeRoot=false)
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
virtual void | setNameCmd (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | resolveRef ()
virtual bool | loadFromXMI1 (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum)
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
QDomElement | save1 (const QString &tag, QDomDocument &qDoc)
bool | isUMLActor ()
bool | isUMLArtifact ()
bool | isUMLAssociation ()
bool | isUMLAttribute ()
bool | isUMLCategory ()
bool | isUMLCheckConstraint ()
bool | isUMLClassifier ()
bool | isUMLComponent ()
bool | isUMLDatatype ()
bool | isUMLEntity ()
bool | isUMLEntityAttribute ()
bool | isUMLEntityConstraint ()
bool | isUMLEnum ()
bool | isUMLEnumLiteral ()
bool | isUMLFolder ()
bool | isUMLForeignKeyConstraint ()
bool | isUMLInstance ()
bool | isUMLInstanceAttribute ()
bool | isUMLNode ()
bool | isUMLObject ()
bool | isUMLOperation ()
bool | isUMLPackage ()
bool | isUMLPort ()
bool | isUMLRole ()
bool | isUMLStereotype ()
bool | isUMLTemplate ()
bool | isUMLUniqueConstraint ()
bool | isUMLUseCase ()
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()

## Protected Attributes
int | m_refCount
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id More...
QString | m_Doc
| object's documentation More...
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable More...
QString | m_name
| objects name More...
ObjectType | m_BaseType
| objects type More...
Uml::Visibility::Enum | m_visibility
| objects visibility More...
bool | m_bAbstract
| state of whether the object is abstract or not More...
bool | m_bStatic
| flag for instance scope More...
bool | m_bInPaste
| caller sets this true when in paste operation More...
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated() More...
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
UMLObjectPrivate * | m_d
| private data More...

## Additional Inherited Members
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1, ot_UMLObject = 100, ot_Actor, ot_UseCase, ot_Package, ot_Interface, ot_Datatype, ot_Enum, ot_Class, ot_Instance, ot_Association, ot_Attribute, ot_Operation, ot_EnumLiteral, ot_Template, ot_Component, ot_Artifact, ot_Node, ot_Stereotype, ot_Role, ot_Entity, ot_EntityAttribute, ot_Folder, ot_EntityConstraint, ot_UniqueConstraint, ot_ForeignKeyConstraint, ot_CheckConstraint, ot_Category, ot_Port, ot_InstanceAttribute, ot_SubSystem }
Public Slots inherited from UMLObject
void | emitModified ()
Signals inherited from UMLObject
void | modified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()
virtual bool | load1 (QDomElement &element)

## Detailed Description

Sets up stereotype information.

This class is used to set up information for a stereotype. Stereotypes are used essentially as properties of attributes and operations etc.

Each stereotype object is reference counted, i.e. client code manages it such that it comes into existence as soon as there is at least one user, and ceases existing when the number of users drops to 0. m_refCount reflects the number of users. It is externally managed, i.e. client code must take care to call incrRefCount() and decrRefCount() as appropriate.

The one and only owner of all stereotypes is the UMLDoc, and the ownership is specially managed (umlPackage() returns NULL for a UMLStereotype.) The reason for this special treatment is that class UMLDoc does not inherit from class UMLPackage, and therefore setUMLPackage() cannot be used for stereotypes.

Author
  Jonathan Riddell
  Oliver Kellogg Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ UMLStereotype() [1/2]

UMLStereotype::UMLStereotype | ( | const QString & | name,
|  | Uml::ID::Type | id = `Uml::ID::None`
| ) |  |
| explicit

Sets up a stereotype.

Parameters

  name | The name of this UMLStereotype.
  id | The unique id given to this UMLStereotype.

## ◆ UMLStereotype() [2/2]

UMLStereotype::UMLStereotype | ( |  | ) |

Sets up a stereotype.

## ◆ ~UMLStereotype()

UMLStereotype::~UMLStereotype | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ clone()

UMLObject * UMLStereotype::clone | ( |  | ) | const
| virtual

Make a clone of this object.

Reimplemented from UMLObject.

## ◆ copyInto()

void UMLStereotype::copyInto | ( | UMLObject * | lhs | ) | const
| virtual

Copy the internal presentation of this object into the new object.

Reimplemented from UMLObject.

## ◆ decrRefCount()

void UMLStereotype::decrRefCount | ( |  | ) |

Decrements the reference count for this stereotype.

## ◆ incrRefCount()

void UMLStereotype::incrRefCount | ( |  | ) |

Increments the reference count for this stereotype.

## ◆ name()

QString UMLStereotype::name | ( | bool | includeAdornments = `false` | ) | const

Returns the name as string

## ◆ operator==()

bool UMLStereotype::operator== | ( | const UMLStereotype & | rhs | ) | const

Overloaded '==' operator.

## ◆ refCount()

int UMLStereotype::refCount | ( |  | ) | const

Returns the reference count for this stereotype.

## ◆ saveToXMI1()

void UMLStereotype::saveToXMI1 | ( | QDomDocument & | qDoc,
|  | QDomElement & | qElement
| ) |  |
| virtual

Saves to the <UML:StereoType> XMI element.

Reimplemented from UMLObject.

## ◆ showPropertiesDialog()

bool UMLStereotype::showPropertiesDialog | ( | QWidget * | parent | ) |
| virtual

Display the properties configuration dialog for the stereotype (just a line edit).

Reimplemented from UMLObject.

## Member Data Documentation

## ◆ m_refCount

int UMLStereotype::m_refCount
| protected

The documentation for this class was generated from the following files:

- umbrello/uml1model/stereotype.h
- umbrello/uml1model/stereotype.cpp